#!/usr/local/bin/python
#
# Copyright (c) 1996 by Lele Gaifax.  All Rights Reserved
#
# This file is part of Nothing (yet).
#
# $RCSfile: Forward.py,v $
# $Revision: 1.1.1.1 $
# $Date: 1996/09/30 06:06:50 $
#
# Created Thu Sep  5 17:43:51 1996.
#

import ObjC

NXBundle = ObjC.lookup_class ('NXBundle')

class Delegate:
    def printThisString__nTimes__ (self, str, ntimes):
	result = str * ntimes
	print result
	return result
    # end def
# end class

fw_bundle = NXBundle.alloc().initForDirectory__ ('Forward.bundle')
Forwarder = fw_bundle.principalClass()

if Forwarder:
    delegate = Delegate()
    result_ok = "This is a test string"*3
    print "You should get '%s'" % result_ok
    print "=>",
    forwarder = Forwarder.new()
    forwarder.setDelegate__ (delegate)
    result = forwarder.performMethodOnDelegate()
    print result == result_ok and "Everything seems OK!" or "Nop! I got `%s'" % result

    print
    print "Checking whether forwarder responds to `printThisString:nTimes:'...", 
    print forwarder.respondsTo__ ('printThisString:nTimes:') and "YES!" or "No??!?!?!"
    print "Checking whether forwarder responds to `thisMethod:doesNotExist:'...", 
    print forwarder.respondsTo__ ('thisMethod:doesNotExist:') and "Yes??!?!?!" or "NO!"

    print
    print "Trying `forwarder.thisMethod__doesNotExist__ (None, None)'..."
    try:
	forwarder.thisMethod__doesNotExist__ (None, None)
    except ObjC.error, m:
	print "As expected, an ObjC.error:", m
    else:
	print "Strange, very strange: forwarder swallowed it..."
    # end try

    print
    print "Trying `forwarder.performUnknownMethodOnDelegate()'..."
    try:
	forwarder.performUnknownMethodOnDelegate()
    except ObjC.error, m:
	print "Again, everything OK with it: the forwarder handled the message but the delegate"
	print "couldn't respond to it:", m
    else:
	print "What is going on here?"
    # end try
else:
    print "Something wrong!"
# end if

