/* Copyright (c) 1996 by Lele Gaifax.  All Rights Reserved
 *
 * This file is part of Nothing (yet).
 *
 * $RCSfile: Forwarder.m,v $
 * $Revision: 1.1.1.1 $
 * $Date: 1996/09/30 06:06:51 $
 *
 * Created Thu Sep  5 17:38:43 1996.
 */

#include "Forwarder.h"
#include "OC_PythonString.h"
#include "OC_PythonInt.h"

#define CLASS_VERSION 0

@implementation Forwarder

+ (void) initialize
{
  if (self == [Forwarder class])
    {
      [Forwarder setVersion:CLASS_VERSION];
    }
}

- (void) setDelegate:(id <PythonObject>) aDelegate
{
  delegate = aDelegate;
}

- (BOOL) respondsTo:(SEL) aSelector
{
  return [delegate respondsTo:aSelector];
}

- performMethodOnDelegate
{
  return [delegate printThisString:[OC_PythonString fromString:"This is a test string"]
		   nTimes:[OC_PythonInt fromLong:3]];
}

- performUnknownMethodOnDelegate
{
  return [delegate thisMethod:nil
		   doesNotExist:nil];
}

@end /* Forwarder class implementation */
